#include "DrawingObjects.h"

const int hex_num_edge=12;
const int hex_edges[hex_num_edge][2] =
  {
    {0,1} ,{1,2},{2,3},{3,0},{0,4},{1,7},{2,6},{3,5},{4,5},{5,6},{6,7},{7,4}
  };
const int hex_iso_table[][43] = { 
    { 0 },
    { 1, 3, 0, 3, 0, 1, 0, 4 },
    { 1, 3, 0, 1, 1, 2, 1, 7 },
    { 2, 
      3, 0, 3, 1, 2, 0, 4, 
      3, 1, 2, 1, 7, 0, 4 }, 
    { 1, 3, 1, 2, 2, 3, 2, 6 },
    { 2,
      3, 1, 2, 2, 3, 2, 6,
      3, 0, 3, 0, 1, 0, 4 },
    { 2,
      3, 0, 1, 2, 3, 2, 6,
      3, 0, 1, 2, 6, 1, 7 },
    { 3,
      3, 0, 3, 2, 3, 0, 4,
      3, 0, 4, 2, 3, 2, 6,
      3, 1, 7, 0, 4, 2, 6 },

    { 1, 3, 0, 3, 3, 5, 2, 3 },
    { 2,
      3, 0, 1, 0, 4, 2, 3,
      3, 0, 4, 3, 5, 2, 3 },      
    { 2, 
      3, 0, 1, 1, 2, 1, 7,
      3, 0, 3, 3, 5, 2, 3 },
    { 3, 
      3, 1, 7, 0, 4, 3, 5,
      3, 1, 2, 1, 7, 2, 3,
      3, 2, 3, 1, 7, 3, 5 },
    { 2,
      3, 0, 3, 3, 5, 1, 2,
      3, 1, 2, 3, 5, 2, 6 },
    { 3,
      3, 0, 4, 3, 5, 2, 6,
      3, 1, 2, 0, 1, 0, 4, 
      3, 0, 4, 2, 6, 1, 2 },
    { 3,
      3, 1, 7, 3, 5, 2, 6,
      3, 1, 7, 0, 1, 3, 5,
      3, 0, 1, 0, 3, 3, 5 },
    { 2,
      3, 0, 4, 3, 5, 2, 6,
      3, 0, 4, 2, 6, 1, 7 },
    { 1, 3, 0, 4, 4, 7, 4, 5 },
    { 2,
      3, 0, 3, 0, 1, 4, 7,
      3, 0, 3, 4, 7, 4, 5 },
    { 2,
      3, 0, 4, 4, 7, 4, 5,
      3, 0, 1, 1, 2, 1, 7 },
    { 3,
      3, 0, 3, 1, 2, 4, 5,
      3, 4, 5, 1, 2, 1, 7,
      3, 1, 7, 4, 7, 4, 5 },
    { 2,
      3, 0, 4, 4, 7, 4, 5,
      3, 1, 2, 2, 3, 2, 6 },
    { 3,
      3, 0, 3, 0, 1, 4, 7,
      3, 0, 3, 4, 7, 4, 5,
      3, 1, 2, 2, 3, 2, 6 },
    { 3,
      3, 0, 4, 4, 7, 4, 5,
      3, 0, 1, 2, 3, 2, 6,
      3, 2, 6, 1, 7, 0, 1 },
    { 4,
      3, 0, 3, 2, 3, 4, 5,
      3, 4, 5, 2, 3, 1, 7,
      3, 1, 7, 2, 3, 2, 6,
      3, 1, 7, 4, 7, 4, 5 },
    { 2,
      3, 0, 4, 4, 7, 4, 5,
      3, 0, 3, 3, 5, 2, 3 },
    { 3,
      3, 4, 5, 3, 5, 2, 3,
      3, 2, 3, 4, 7, 4, 5,
      3, 4, 7, 2, 3, 0, 1 },
    { 3,
      3, 0, 4, 4, 7, 4, 5,
      3, 0, 1, 1, 2, 1, 7,
      3, 0, 3, 3, 5, 2, 3 },
    { 4,
      3, 1, 7, 4, 7, 4, 5,
      3, 4, 5, 3, 5, 1, 7,
      3, 1, 7, 3, 5, 1, 2,
      3, 1, 2, 3, 5, 2, 3 },
    { 3,
      3, 0, 4, 4, 7, 4, 5,
      3, 0, 3, 3, 5, 1, 2,
      3, 1, 2, 3, 5, 2, 6 },
    { 4,
      3, 4, 7, 4, 5, 3, 5,
      3, 3, 5, 1, 2, 4, 7,
      3, 4, 7, 1, 2, 0, 1,
      3, 1, 2, 3, 5, 2, 6 },
    { 4,
      3, 0, 4, 4, 7, 4, 5,
      3, 0, 1, 0, 3, 1, 7,
      3, 1, 7, 0, 3, 3, 5,
      3, 1, 7, 3, 5, 2, 6 },
    { 3,
      3, 1, 7, 3, 5, 2, 6,
      3, 1, 7, 4, 5, 3, 5, 
      3, 1, 7, 4, 7, 4, 5 },
    { 1, 3, 3, 5, 4, 5, 5, 6 },
    { 2,
      3, 0, 1, 0, 4, 0, 3,
      3, 3, 5, 4, 5, 5, 6 },
    { 2,
      3, 4, 5, 5, 6, 3, 5,
      3, 0, 1, 1, 2, 1, 7 },
    { 3,
      3, 4, 5, 5, 6, 3, 5,
      3, 0, 4, 0, 3, 1, 2,
      3, 0, 4, 1, 2, 1, 7 },
    { 2,
      3, 4, 5, 5, 6, 3, 5,
      3, 1, 2, 2, 3, 2, 6 },
    { 3,
      3, 4, 5, 5, 6, 3, 5,
      3, 1, 2, 2, 3, 2, 6,
      3, 0, 1, 0, 4, 0, 3 },
    { 3,
      3, 4, 5, 5, 6, 3, 5,
      3, 0, 1, 2, 3, 1, 7,
      3, 1, 7, 2, 3, 2, 6 },
    { 4,
      3, 4, 5, 5, 6, 3, 5,
      3, 1, 7, 0, 4, 2, 6,
      3, 2, 6, 0, 4, 0, 3,
      3, 0, 3, 2, 3, 2, 6 },
    { 2, 
      3, 0, 3, 4, 5, 5, 6,
      3, 5, 6, 2, 3, 0, 3 },
    { 3,
      3, 0, 1, 5, 6, 2, 3,
      3, 0, 1, 0, 4, 5, 6,
      3, 0, 4, 4, 5, 5, 6 },
    { 3,
      3, 0, 1, 1, 2, 1, 7,
      3, 0, 3, 4, 5, 5, 6,
      3, 2, 3, 0, 3, 5, 6 },
    { 4,
      3, 1, 7, 0, 4, 1, 2,
      3, 1, 2, 0, 4, 5, 6,
      3, 1, 2, 5, 6, 2, 3,
      3, 0, 4, 4, 5, 5, 6 },
    { 3,
      3, 0, 3, 4, 5, 1, 2,
      3, 1, 2, 4, 5, 5, 6,
      3, 5, 6, 2, 6, 1, 2 },
    { 4,
      3, 0, 1, 0, 4, 4, 5,
      3, 0, 1, 4, 5, 5, 6,
      3, 0, 1, 5, 6, 1, 2,
      3, 1, 2, 5, 6, 2, 6 },
    { 4,
      3, 0, 1, 0, 3, 1, 7,
      3, 1, 7, 0, 3, 5, 6,
      3, 1, 7, 5, 6, 2, 6,
      3, 0, 3, 4, 5, 5, 6 },
    { 3,
      3, 1, 7, 0, 4, 2, 6,
      3, 0, 4, 4, 5, 5, 6,
      3, 0, 4, 5, 6, 2, 6 },
    { 2, 
      3, 3, 5, 0, 4, 4, 7,
      3, 3, 5, 4, 7, 5, 6 },
    { 3,
      3, 0, 1, 4, 7, 5, 6,
      3, 0, 3, 0, 1, 5, 6,
      3, 5, 6, 3, 5, 0, 3 },
    { 3, 
      3, 0, 1, 1, 2, 1, 7,
      3, 0, 4, 4, 7, 5, 6,
      3, 5, 6, 3, 5, 0, 4 },
    { 4, 
      3, 0, 3, 1, 2, 3, 5,
      3, 3, 5, 1, 2, 4, 7,
      3, 4, 7, 1, 2, 1, 7,
      3, 5, 6, 3, 5, 4, 7 },
    { 3,
      3, 1, 2, 2, 3, 2, 6,
      3, 3, 5, 0, 4, 4, 7,
      3, 4, 7, 5, 6, 3, 5 },
    { 4,
      3, 1, 2, 2, 3, 2, 6,
      3, 0, 1, 4, 7, 5, 6,
      3, 5, 6, 3, 5, 0, 3,
      3, 0, 3, 0, 1, 5, 6 },
    { 4,
      3, 0, 1, 2, 3, 2, 6, 
      3, 2, 6, 1, 7, 0, 1,
      3, 0, 4, 4, 7, 5, 6,
      3, 5, 6, 3, 5, 0, 4 },
    { 3,
      3, 0, 3, 2, 3, 3, 5,
      3, 1, 7, 4, 7, 5, 6,
      3, 5, 6, 2, 6, 1, 7 },
    { 3,
      3, 0, 3, 0, 4, 2, 3,
      3, 2, 3, 0, 4, 4, 7,
      3, 2, 3, 4, 7, 5, 6 },
    { 2,
      3, 2, 3, 0, 1, 4, 7,
      3, 2, 3, 4, 7, 5, 6 },
    { 4,
      3, 0, 1, 1, 2, 1, 7,
      3, 0, 3, 0, 4, 2, 3, 
      3, 2, 3, 0, 4, 4, 7,
      3, 2, 3, 4, 7, 5, 6 },
    { 3,
      3, 4, 7, 5, 6, 2, 3,
      3, 4, 7, 2, 3, 1, 7,
      3, 1, 7, 2, 3, 1, 2 },
    { 4,
      3, 0, 3, 0, 4, 1, 2,
      3, 0, 4, 5, 6, 1, 2,
      3, 1, 2, 5, 6, 2, 6,
      3, 0, 4, 4, 7, 5, 6 },
    { 3,
      3, 0, 1, 4, 7, 5, 6,
      3, 0, 1, 5, 6, 1, 2,
      3, 1, 2, 5, 6, 2, 6 },
    { 3,
      3, 0, 1, 0, 3, 0, 4,
      3, 1, 7, 4, 7, 5, 6,
      3, 5, 6, 2, 6, 1, 7 },
    { 2,
      3, 1, 7, 4, 7, 5, 6,
      3, 5, 6, 2, 6, 1, 7 },
    { 1, 3, 6, 7, 2, 6, 5, 6 },
    { 2,
      3, 0, 1, 0, 4, 0, 3,
      3, 2, 6, 5, 6, 6, 7 },
    { 2,
      3, 0, 1, 1, 2, 1, 7,
      3, 2, 6, 5, 6, 6, 7 },
    { 3,
      3, 2, 6, 5, 6, 6, 7,
      3, 0, 3, 1, 2, 0, 4,
      3, 0, 4, 1, 2, 1, 7 }, 
    { 2,
      3, 2, 3, 6, 7, 1, 2,
      3, 2, 3, 5, 6, 6, 7 },
    { 3,
      3, 2, 3, 6, 7, 1, 2,
      3, 2, 3, 5, 6, 6, 7,
      3, 0, 1, 0, 4, 0, 3 },
    { 3,
      3, 0, 1, 2, 3, 5, 6, 
      3, 0, 1, 5, 6, 6, 7,
      3, 6, 7, 1, 7, 0, 1 },
    { 4,
      3, 0, 3, 2, 3, 5, 6,
      3, 1, 7, 0, 3, 5, 6,
      3, 1, 7, 5, 6, 6, 7,
      3, 1, 7, 0, 4, 0, 3 },
    { 2,
      3, 6, 7, 2, 6, 5, 6,
      3, 0, 3, 3, 5, 2, 3 },
    { 3,
      3, 0, 1, 0, 4, 2, 3,
      3, 0, 4, 3, 5, 2, 3,
      3, 2, 6, 5, 6, 6, 7 },
    { 3,
      3, 0, 3, 3, 5, 2, 3,
      3, 0, 1, 1, 2, 1, 7,
      3, 2, 6, 5, 6, 6, 7 },
    { 4,
      3, 2, 6, 5, 6, 6, 7,
      3, 0, 4, 3, 5, 1, 7,
      3, 1, 7, 3, 5, 1, 2,
      3, 1, 2, 3, 5, 2, 3 },
    { 3,
      3, 0, 3, 6, 7, 1, 2,
      3, 0, 3, 3, 5, 6, 7,
      3, 6, 7, 3, 5, 5, 6 },
    { 4,
      3, 0, 1, 0, 4, 1, 2,
      3, 1, 2, 0, 4, 5, 6,
      3, 1, 2, 5, 6, 6, 7,
      3, 0, 4, 3, 5, 5, 6 },
    { 4, 
      3, 1, 7, 0, 1, 6, 7,
      3, 6, 7, 0, 1, 0, 3,
      3, 6, 7, 0, 3, 5, 6,
      3, 5, 6, 0, 3, 3, 5 },
    { 3,
      3, 1, 7, 0, 4, 3, 5,
      3, 1, 7, 3, 5, 6, 7,
      3, 6, 7, 3, 5, 5, 6 },
    { 2,
      3, 0, 4, 4, 7, 4, 5,
      3, 2, 6, 5, 6, 6, 7 },
    { 3,
      3, 0, 1, 4, 7, 0, 3,
      3, 4, 7, 4, 5, 0, 3,
      3, 2, 6, 5, 6, 6, 7 },
    { 3,
      3, 0, 4, 4, 7, 4, 5,
      3, 0, 1, 1, 2, 1, 7,
      3, 2, 6, 5, 6, 6, 7 },
    { 4, 
      3, 2, 6, 5, 6, 6, 7,
      3, 0, 3, 1, 2, 4, 5,
      3, 4, 7, 4, 5, 1, 2, 
      3, 1, 2, 1, 7, 4, 7 },
    { 3,
      3, 0, 4, 4, 7, 4, 5,
      3, 1, 2, 2, 3, 6, 7,
      3, 6, 7, 2, 3, 5, 6 },
    { 4,
      3, 1, 2, 2, 3, 6, 7,
      3, 6, 7, 2, 3, 5, 6,
      3, 0, 1, 4, 7, 4, 5,
      3, 4, 5, 0, 3, 0, 1 },
    { 4, 
      3, 0, 4, 4, 7, 4, 5,
      3, 0, 1, 2, 3, 5, 6,
      3, 0, 1, 5, 6, 1, 7,
      3, 1, 7, 5, 6, 6, 7 },
    { 3,
      3, 1, 7, 4, 7, 6, 7,
      3, 0, 3, 2, 3, 4, 5,
      3, 4, 5, 2, 3, 5, 6 },
    { 3,
      3, 0, 4, 4, 7, 4, 5,
      3, 0, 3, 3, 5, 2, 3,
      3, 2, 6, 5, 6, 6, 7 },
    { 4,
      3, 2, 6, 5, 6, 6, 7,
      3, 2, 3, 0, 1, 4, 7,
      3, 4, 7, 4, 5, 3, 5, 
      3, 3, 5, 2, 3, 4, 7 },
    { 4,
      3, 0, 4, 4, 7, 4, 5,
      3, 0, 3, 3, 5, 2, 3,
      3, 0, 1, 1, 2, 1, 7,
      3, 2, 6, 5, 6, 6, 7 },
    { 3,
      3, 3, 5, 5, 6, 4, 5,
      3, 1, 7, 4, 7, 6, 7,
      3, 1, 2, 2, 6, 2, 3 },
    { 4,
      3, 0, 4, 4, 7, 4, 5,
      3, 1, 2, 0, 3, 6, 7,
      3, 6, 7, 0, 3, 5, 6,
      3, 5, 6, 0, 3, 3, 5 },
    { 3,
      3, 3, 5, 5, 6, 4, 5,
      3, 0, 1, 4, 7, 1, 2,
      3, 1, 2, 4, 7, 6, 7 },
    { 3, 
      3, 0, 1, 0, 3, 0, 4,
      3, 3, 5, 5, 6, 4, 5,
      3, 1, 7, 4, 7, 6, 7 },
    { 2,
      3, 4, 5, 3, 5, 5, 6,
      3, 1, 7, 4, 7, 6, 7 },
    { 2, 
      3, 3, 5, 4, 5, 2, 6,
      3, 2, 6, 4, 5, 6, 7 },
    { 3,
      3, 3, 5, 4, 5, 2, 6,
      3, 2, 6, 4, 5, 6, 7,
      3, 0, 1, 0, 4, 0, 3 },
    { 3,
      3, 3, 5, 4, 5, 2, 6,
      3, 2, 6, 4, 5, 6, 7,
      3, 0, 1, 1, 2, 1, 7 },
    { 4,
      3, 3, 5, 4, 5, 2, 6,
      3, 2, 6, 4, 5, 6, 7,
      3, 1, 2, 1, 7, 0, 4,
      3, 0, 4, 0, 3, 1, 2 },
    { 3,
      3, 1, 2, 4, 5, 6, 7,
      3, 4, 5, 1, 2, 2, 3,
      3, 4, 5, 2, 3, 3, 5 },
    { 4,
      3, 1, 2, 4, 5, 6, 7,
      3, 4, 5, 1, 2, 2, 3,
      3, 4, 5, 2, 3, 3, 5,
      3, 0, 1, 0, 4, 0, 3 },
    { 4,
      3, 0, 1, 2, 3, 3, 5,
      3, 0, 1, 3, 5, 6, 7,
      3, 0, 1, 6, 7, 1, 7,
      3, 6, 7, 3, 5, 4, 5 },
    { 3,
      3, 0, 3, 2, 3, 3, 5,
      3, 1, 7, 0, 4, 6, 7,
      3, 6, 7, 0, 4, 4, 5 },
    { 3,
      3, 0, 3, 4, 5, 6, 7,
      3, 0, 3, 6, 7, 2, 3,
      3, 2, 3, 6, 7, 2, 6 },
    { 4,
      3, 0, 1, 0, 4, 2, 3,
      3, 2, 3, 0, 4, 6, 7,
      3, 2, 3, 6, 7, 2, 6,
      3, 0, 4, 4, 5, 6, 7 },
    { 4,
      3, 0, 1, 1, 2, 1, 7,
      3, 0, 3, 4, 5, 6, 7,
      3, 0, 3, 6, 7, 2, 3,
      3, 2, 3, 6, 7, 2, 6 },
    { 3,
      3, 1, 2, 2, 6, 2, 3,
      3, 1, 7, 0, 4, 6, 7,
      3, 0, 4, 4, 5, 6, 7 },
    { 2,
      3, 1, 2, 0, 3, 4, 5,
      3, 1, 2, 4, 5, 6, 7 },
    { 3,
      3, 1, 2, 4, 5, 6, 7,
      3, 1, 2, 0, 4, 4, 5,
      3, 1, 2, 0, 1, 0, 4 },
    { 3,
      3, 0, 3, 4, 5, 6, 7,
      3, 0, 3, 6, 7, 0, 1,
      3, 0, 1, 6, 7, 1, 7 },
    { 2,
      3, 1, 7, 0, 4, 6, 7,
      3, 6, 7, 0, 4, 4, 5 },
    { 3,
      3, 0, 4, 2, 6, 3, 5,
      3, 0, 4, 4, 7, 2, 6,
      3, 4, 7, 6, 7, 2, 6 },
    { 4, 
      3, 0, 1, 4, 7, 0, 3,
      3, 0, 3, 4, 7, 2, 6,
      3, 2, 6, 4, 7, 6, 7,
      3, 3, 5, 0, 3, 2, 6 },
    { 4,
      3, 0, 4, 2, 6, 3, 5,
      3, 0, 4, 4, 7, 2, 6,
      3, 4, 7, 6, 7, 2, 6,
      3, 0, 1, 1, 2, 1, 7 },
    { 3,
      3, 1, 7, 4, 7, 6, 7,
      3, 0, 3, 1, 2, 3, 5,
      3, 3, 5, 1, 2, 2, 6 },
    { 4,
      3, 0, 4, 2, 3, 3, 5,
      3, 0, 4, 6, 7, 2, 3,
      3, 0, 4, 4, 7, 6, 7,
      3, 1, 2, 2, 3, 6, 7 },
    { 3,
      3, 0, 3, 2, 3, 3, 5,
      3, 0, 1, 4, 7, 1, 2,
      3, 1, 2, 4, 7, 6, 7 },
    { 3, 
      3, 1, 7, 4, 7, 6, 7,
      3, 0, 4, 2, 3, 3, 5, 
      3, 0, 4, 0, 1, 2, 3 },
    { 2,
      3, 0, 3, 2, 3, 3, 5,
      3, 1, 7, 4, 7, 6, 7 },
    { 4,
      3, 0, 4, 2, 3, 0, 3,
      3, 2, 3, 0, 4, 4, 7,
      3, 2, 3, 4, 7, 2, 6,
      3, 2, 6, 4, 7, 6, 7 },
    { 3,
      3, 0, 1, 4, 7, 2, 3,
      3, 2, 3, 4, 7, 2, 6,
      3, 2, 6, 4, 7, 6, 7 },
    { 3,
      3, 0, 1, 0, 3, 0, 4,
      3, 2, 3, 1, 2, 2, 6,
      3, 1, 7, 4, 7, 6, 7 },
    { 2,
      3, 2, 3, 1, 2, 2, 6,
      3, 6, 7, 1, 7, 4, 7 },
    { 3,
      3, 0, 3, 6, 7, 1, 2,
      3, 0, 3, 4, 7, 6, 7,
      3, 0, 3, 0, 4, 4, 7 },
    { 2, 
      3, 1, 2, 0, 1, 4, 7,
      3, 4, 7, 6, 7, 1, 2 },
    { 2,
      3, 0, 1, 0, 3, 0, 4,
      3, 1, 7, 4, 7, 6, 7 },

    { 1, 3, 1, 7, 4, 7, 6, 7 },
    { 1, 3, 1, 7, 6, 7, 4, 7 },
    { 2,
      3, 0, 1, 0, 4, 0, 3,
      3, 1, 7, 6, 7, 4, 7 },
    { 2, 
      3, 1, 2, 4, 7, 0, 1,
      3, 4, 7, 1, 2, 6, 7 },
    { 3,
      3, 0, 3, 1, 2, 6, 7,
      3, 0, 3, 6, 7, 4, 7,
      3, 0, 3, 4, 7, 0, 4 },
    { 2,
      3, 2, 3, 2, 6, 1, 2,
      3, 6, 7, 4, 7, 1, 7 },
    { 3,
      3, 0, 1, 0, 4, 0, 3,
      3, 2, 3, 2, 6, 1, 2,
      3, 1, 7, 6, 7, 4, 7 },
    { 3,
      3, 0, 1, 2, 3, 4, 7,
      3, 2, 3, 2, 6, 4, 7,
      3, 2, 6, 6, 7, 4, 7 },
    { 4,
      3, 0, 4, 0, 3, 2, 3,
      3, 2, 3, 4, 7, 0, 4,
      3, 2, 3, 2, 6, 4, 7,
      3, 2, 6, 6, 7, 4, 7 },
    { 2,
      3, 0, 3, 3, 5, 2, 3,
      3, 1, 7, 6, 7, 4, 7 },
    { 3, 
      3, 1, 7, 6, 7, 4, 7,
      3, 0, 4, 3, 5, 2, 3, 
      3, 0, 4, 2, 3, 0, 1 },
    { 3,
      3, 0, 3, 3, 5, 2, 3,
      3, 0, 1, 1, 2, 4, 7,
      3, 1, 2, 6, 7, 4, 7 },
    { 4,
      3, 0, 4, 3, 5, 2, 3,
      3, 0, 4, 2, 3, 6, 7,
      3, 0, 4, 6, 7, 4, 7,
      3, 1, 2, 6, 7, 2, 3 },
    { 3,
      3, 1, 7, 6, 7, 4, 7,
      3, 0, 3, 3, 5, 1, 2,
      3, 3, 5, 2, 6, 1, 2 },
    { 4,
      3, 0, 4, 3, 5, 2, 6,
      3, 0, 4, 2, 6, 4, 7,
      3, 4, 7, 2, 6, 6, 7,
      3, 0, 1, 1, 7, 1, 2 },
    { 4, 
      3, 0, 1, 0, 3, 4, 7,
      3, 0, 3, 2, 6, 4, 7,
      3, 2, 6, 6, 7, 4, 7,
      3, 3, 5, 2, 6, 0, 3 },
    { 3,
      3, 0, 4, 3, 5, 2, 6,
      3, 0, 4, 2, 6, 4, 7,
      3, 4, 7, 2, 6, 6, 7 },
    { 2,
      3, 1, 7, 6, 7, 0, 4,
      3, 6, 7, 4, 5, 0, 4 },
    { 3,
      3, 0, 3, 6, 7, 4, 5,
      3, 0, 3, 0, 1, 6, 7,
      3, 0, 1, 1, 7, 6, 7 },
    { 3,
      3, 1, 2, 6, 7, 4, 5,
      3, 1, 2, 4, 5, 0, 4,
      3, 1, 2, 0, 4, 0, 1 },
    { 2,
      3, 1, 2, 4, 5, 0, 3,
      3, 1, 2, 6, 7, 4, 5 },
    { 3,
      3, 1, 2, 2, 3, 2, 6,
      3, 1, 7, 6, 7, 0, 4,
      3, 0, 4, 6, 7, 4, 5 },
    { 4,
      3, 0, 1, 1, 7, 1, 2,
      3, 0, 3, 6, 7, 4, 5,
      3, 0, 3, 2, 3, 6, 7,
      3, 2, 3, 2, 6, 6, 7 },
    { 4,
      3, 0, 1, 2, 3, 0, 4,
      3, 2, 3, 6, 7, 0, 4,
      3, 2, 3, 2, 6, 6, 7,
      3, 0, 4, 6, 7, 4, 5 },
    { 3,
      3, 0, 3, 6, 7, 4, 5,
      3, 0, 3, 2, 3, 6, 7,
      3, 2, 3, 2, 6, 6, 7 },
    { 3,
      3, 0, 3, 3, 5, 2, 3,
      3, 1, 7, 6, 7, 0, 4,
      3, 6, 7, 4, 5, 0, 4 },
    { 4,
      3, 0, 1, 3, 5, 2, 3,
      3, 0, 1, 6, 7, 3, 5,
      3, 0, 1, 1, 7, 6, 7,
      3, 6, 7, 4, 5, 3, 5 },
    { 4,
      3, 1, 2, 6, 7, 4, 5,
      3, 4, 5, 2, 3, 1, 2,
      3, 4, 5, 3, 5, 2, 3,
      3, 0, 1, 0, 3, 0, 4 },
    { 3,
      3, 1, 2, 6, 7, 4, 5,
      3, 4, 5, 2, 3, 1, 2,
      3, 4, 5, 3, 5, 2, 3 },
    { 4,
      3, 3, 5, 2, 6, 4, 5,
      3, 2, 6, 6, 7, 4, 5,
      3, 1, 2, 0, 4, 1, 7,
      3, 0, 4, 1, 2, 0, 3 },
    { 3,
      3, 3, 5, 2, 6, 4, 5,
      3, 2, 6, 6, 7, 4, 5,
      3, 0, 1, 1, 7, 1, 2 },
    { 3,
      3, 3, 5, 2, 6, 4, 5,
      3, 2, 6, 6, 7, 4, 5,
      3, 0, 1, 0, 3, 0, 4 },
    { 2, 
      3, 3, 5, 2, 6, 4, 5,
      3, 2, 6, 6, 7, 4, 5 },
    { 2,
      3, 4, 5, 5, 6, 3, 5,
      3, 1, 7, 6, 7, 4, 7 },
    { 3, 
      3, 0, 1, 0, 4, 0, 3,
      3, 3, 5, 4, 5, 5, 6,
      3, 1, 7, 6, 7, 4, 7 },
    { 3,
      3, 3, 5, 4, 5, 5, 6,
      3, 0, 1, 1, 2, 4, 7,
      3, 1, 2, 6, 7, 4, 7 },
    { 4,
      3, 0, 4, 4, 5, 4, 7,
      3, 1, 2, 6, 7, 0, 3,
      3, 6, 7, 5, 6, 0, 3,
      3, 5, 6, 3, 5, 0, 3 },
    { 3,
      3, 3, 5, 4, 5, 5, 6,
      3, 1, 7, 6, 7, 4, 7,
      3, 1, 2, 2, 3, 2, 6 },
    { 4,
      3, 0, 4, 4, 5, 4, 7,
      3, 0, 3, 2, 3, 3, 5,
      3, 0, 1, 1, 7, 1, 2,
      3, 2, 6, 6, 7, 5, 6 },
    { 4,
      3, 2, 6, 6, 7, 5, 6,
      3, 2, 3, 4, 7, 0, 1,
      3, 4, 7, 3, 5, 4, 5, 
      3, 3, 5, 4, 7, 2, 3 },
    { 3,
      3, 0, 4, 4, 5, 4, 7,
      3, 0, 3, 2, 3, 3, 5,
      3, 2, 6, 6, 7, 5, 6 },
    { 3,
      3, 1, 7, 6, 7, 4, 7,
      3, 0, 3, 4, 5, 2, 3,
      3, 4, 5, 5, 6, 2, 3 },
    { 4, 
      3, 0, 4, 4, 5, 4, 7,
      3, 0, 1, 5, 6, 2, 3,
      3, 0, 1, 1, 7, 5, 6,
      3, 1, 7, 6, 7, 5, 6 },
    { 4,
      3, 1, 2, 6, 7, 2, 3,
      3, 6, 7, 5, 6, 2, 3,
      3, 0, 1, 4, 5, 4, 7,
      3, 4, 5, 0, 1, 0, 3 },
    { 3,
      3, 0, 4, 4, 5, 4, 7,
      3, 1, 2, 6, 7, 2, 3,
      3, 6, 7, 5, 6, 2, 3 },
    { 4, 
      3, 2, 6, 6, 7, 5, 6,
      3, 0, 3, 4, 5, 1, 2,
      3, 4, 7, 1, 2, 4, 5, 
      3, 1, 2, 4, 7, 1, 7 },
    { 3,
      3, 0, 4, 4, 5, 4, 7,
      3, 0, 1, 1, 7, 1, 2,
      3, 2, 6, 6, 7, 5, 6 },
    { 3,
      3, 0, 1, 0, 3, 4, 7,
      3, 4, 7, 0, 3, 4, 5,
      3, 2, 6, 6, 7, 5, 6 },
    { 2,
      3, 0, 4, 4, 5, 4, 7,
      3, 2, 6, 6, 7, 5, 6 },
    { 3,
      3, 1, 7, 3, 5, 0, 4,
      3, 1, 7, 6, 7, 3, 5,
      3, 6, 7, 5, 6, 3, 5 },
    { 4, 
      3, 1, 7, 6, 7, 0, 1,
      3, 6, 7, 0, 3, 0, 1,
      3, 6, 7, 5, 6, 0, 3,
      3, 5, 6, 3, 5, 0, 3 },
    { 4,
      3, 0, 1, 1, 2, 0, 4,
      3, 1, 2, 5, 6, 0, 4,
      3, 1, 2, 6, 7, 5, 6,
      3, 0, 4, 5, 6, 3, 5 },
    { 3,
      3, 0, 3, 1, 2, 6, 7,
      3, 0, 3, 6, 7, 3, 5,
      3, 6, 7, 5, 6, 3, 5, },
    { 4,
      3, 2, 6, 6, 7, 5, 6,
      3, 0, 4, 1, 7, 3, 5,
      3, 1, 7, 1, 2, 3, 5,
      3, 1, 2, 2, 3, 3, 5 },
    { 3,
      3, 0, 3, 2, 3, 3, 5,
      3, 0, 1, 1, 7, 1, 2,
      3, 2, 6, 6, 7, 5, 6 },
    { 3,
      3, 0, 1, 2, 3, 0, 4,
      3, 0, 4, 2, 3, 3, 5,
      3, 2, 6, 6, 7, 5, 6 },
    { 2,
      3, 6, 7, 5, 6, 2, 6,
      3, 0, 3, 2, 3, 3, 5 },
    { 4,
      3, 0, 3, 5, 6, 2, 3,
      3, 1, 7, 5, 6, 0, 3,
      3, 1, 7, 6, 7, 5, 6,
      3, 1, 7, 0, 3, 0, 4 },
    { 3,
      3, 0, 1, 5, 6, 2, 3, 
      3, 0, 1, 6, 7, 5, 6,
      3, 6, 7, 0, 1, 1, 7 },
    { 3,
      3, 2, 3, 1, 2, 6, 7,
      3, 2, 3, 6, 7, 5, 6,
      3, 0, 1, 0, 3, 0, 4 },      
    { 2,
      3, 2, 3, 1, 2, 6, 7,
      3, 2, 3, 6, 7, 5, 6 },
    { 3,
      3, 2, 6, 6, 7, 5, 6,
      3, 0, 3, 0, 4, 1, 2,
      3, 0, 4, 1, 7, 1, 2 },
    { 2,
      3, 0, 1, 1, 7, 1, 2,
      3, 2, 6, 6, 7, 5, 6 },
    { 2,
      3, 0, 1, 0, 3, 0, 4,
      3, 2, 6, 6, 7, 5, 6 },
    { 1, 3, 6, 7, 5, 6, 2, 6 },
    { 2,
      3, 1, 7, 5, 6, 4, 7,
      3, 5, 6, 1, 7, 2, 6 },
    { 3,
      3, 0, 1, 0, 4, 0, 3,
      3, 1, 7, 5, 6, 4, 7,
      3, 5, 6, 1, 7, 2, 6 },
    { 3,
      3, 0, 1, 5, 6, 4, 7,
      3, 0, 1, 1, 2, 5, 6,
      3, 1, 2, 2, 6, 5, 6 },
    { 4,
      3, 0, 3, 1, 2, 0, 4,
      3, 0, 4, 1, 2, 5, 6,
      3, 1, 2, 2, 6, 5, 6,
      3, 0, 4, 5, 6, 4, 7 },
    { 3,
      3, 4, 7, 2, 3, 5, 6,
      3, 4, 7, 1, 7, 2, 3,
      3, 1, 7, 1, 2, 2, 3 },
    { 4,
      3, 0, 1, 1, 7, 1, 2,
      3, 0, 3, 2, 3, 0, 4, 
      3, 2, 3, 4, 7, 0, 4,
      3, 2, 3, 5, 6, 4, 7 },
    { 2,
      3, 2, 3, 4, 7, 0, 1,
      3, 2, 3, 5, 6, 4, 7 },
    { 3,
      3, 0, 3, 2, 3, 0, 4,
      3, 2, 3, 4, 7, 0, 4,
      3, 2, 3, 5, 6, 4, 7 },
    { 3,
      3, 0, 3, 3, 5, 2, 3,
      3, 1, 7, 5, 6, 4, 7,
      3, 5, 6, 1, 7, 2, 6 },
    { 4,
      3, 0, 1, 2, 6, 2, 3, 
      3, 2, 6, 0, 1, 1, 7,
      3, 0, 4, 5, 6, 4, 7,
      3, 5, 6, 0, 4, 3, 5 },
    { 4,
      3, 1, 2, 2, 6, 2, 3,
      3, 0, 1, 5, 6, 4, 7,
      3, 5, 6, 0, 3, 3, 5,
      3, 0, 3, 5, 6, 0, 1 },
    { 3,
      3, 1, 2, 2, 6, 2, 3,
      3, 3, 5, 4, 7, 0, 4,
      3, 4, 7, 3, 5, 5, 6 },
    { 4, 
      3, 0, 3, 3, 5, 1, 2,
      3, 3, 5, 4, 7, 1, 2,
      3, 4, 7, 1, 7, 1, 2,
      3, 5, 6, 4, 7, 3, 5 },
    { 3, 
      3, 0, 1, 1, 7, 1, 2,
      3, 0, 4, 5, 6, 4, 7,
      3, 5, 6, 0, 4, 3, 5 },
    { 3,
      3, 0, 1, 5, 6, 4, 7,
      3, 0, 3, 5, 6, 0, 1,
      3, 5, 6, 0, 3, 3, 5 },
    { 2, 
      3, 3, 5, 4, 7, 0, 4,
      3, 3, 5, 5, 6, 4, 7 },
    { 3,
      3, 1, 7, 2, 6, 0, 4,
      3, 0, 4, 5, 6, 4, 5,
      3, 0, 4, 2, 6, 5, 6 },
    { 4,
      3, 0, 1, 1, 7, 0, 3,
      3, 1, 7, 5, 6, 0, 3,
      3, 1, 7, 2, 6, 5, 6,
      3, 0, 3, 5, 6, 4, 5 },
    { 4,
      3, 0, 1, 4, 5, 0, 4,
      3, 0, 1, 5, 6, 4, 5,
      3, 0, 1, 1, 2, 5, 6,
      3, 1, 2, 2, 6, 5, 6 },
    { 3,
      3, 0, 3, 1, 2, 4, 5,
      3, 1, 2, 5, 6, 4, 5,
      3, 5, 6, 1, 2, 2, 6 },
    { 4,
      3, 1, 7, 1, 2, 0, 4,
      3, 1, 2, 5, 6, 0, 4,
      3, 1, 2, 2, 3, 5, 6,
      3, 0, 4, 5, 6, 4, 5 },
    { 3,
      3, 0, 1, 1, 7, 1, 2,
      3, 0, 3, 5, 6, 4, 5,
      3, 2, 3, 5, 6, 0, 3 },
    { 3,
      3, 0, 1, 2, 3, 5, 6,
      3, 0, 1, 5, 6, 0, 4,
      3, 0, 4, 5, 6, 4, 5 },
    { 2, 
      3, 0, 3, 5, 6, 4, 5,
      3, 5, 6, 0, 3, 2, 3 },
    { 4,
      3, 4, 5, 3, 5, 5, 6,
      3, 1, 7, 2, 6, 0, 4,
      3, 2, 6, 0, 3, 0, 4,
      3, 0, 3, 2, 6, 2, 3 },
    { 3,
      3, 4, 5, 3, 5, 5, 6,
      3, 0, 1, 1, 7, 2, 3,
      3, 1, 7, 2, 6, 2, 3 },
    { 3,
      3, 4, 5, 3, 5, 5, 6,
      3, 1, 2, 2, 6, 2, 3,
      3, 0, 1, 0, 3, 0, 4 },
    { 2,
      3, 4, 5, 3, 5, 5, 6,
      3, 1, 2, 2, 6, 2, 3 },
    { 3,
      3, 4, 5, 3, 5, 5, 6,
      3, 0, 4, 1, 2, 0, 3,
      3, 0, 4, 1, 7, 1, 2 },
    { 2,
      3, 4, 5, 3, 5, 5, 6,
      3, 0, 1, 1, 7, 1, 2 },
    { 2,
      3, 0, 1, 0, 3, 0, 4,
      3, 3, 5, 5, 6, 4, 5 },
    { 1, 3, 3, 5, 5, 6, 4, 5 },
    { 3,
      3, 1, 7, 2, 6, 3, 5,
      3, 1, 7, 3, 5, 4, 5, 
      3, 1, 7, 4, 5, 4, 7 },
    { 4,
      3, 0, 4, 4, 5, 4, 7,
      3, 0, 1, 1, 7, 0, 3,
      3, 1, 7, 3, 5, 0, 3,
      3, 1, 7, 2, 6, 3, 5 },
    { 4,
      3, 4, 7, 3, 5, 4, 5,
      3, 3, 5, 4, 7, 1, 2,
      3, 4, 7, 0, 1, 1, 2,
      3, 1, 2, 2, 6, 3, 5 },
    { 3,
      3, 0, 4, 4, 5, 4, 7, 
      3, 0, 3, 1, 2, 3, 5,
      3, 1, 2, 2, 6, 3, 5 },
    { 4,
      3, 1, 7, 4, 5, 4, 7, 
      3, 4, 5, 1, 7, 3, 5, 
      3, 1, 7, 1, 2, 3, 5, 
      3, 1, 2, 2, 3, 3, 5 },
    { 3,
      3, 0, 4, 4, 5, 4, 7, 
      3, 0, 1, 1, 7, 1, 2, 
      3, 0, 3, 2, 3, 3, 5 },
    { 3,
      3, 4, 5, 2, 3, 3, 5, 
      3, 2, 3, 4, 5, 4, 7, 
      3, 4, 7, 0, 1, 2, 3 },
    { 2,
      3, 0, 4, 4, 5, 4, 7, 
      3, 0, 3, 2, 3, 3, 5 },
    { 4,
      3, 0, 3, 4, 5, 2, 3, 
      3, 4, 5, 1, 7, 2, 3, 
      3, 1, 7, 2, 6, 2, 3, 
      3, 1, 7, 4, 5, 4, 7 },
    { 3,
      3, 0, 4, 4, 5, 4, 7, 
      3, 0, 1, 2, 6, 2, 3, 
      3, 2, 6, 0, 1, 1, 7 },
    { 3,
      3, 0, 3, 4, 7, 0, 1, 
      3, 0, 3, 4, 5, 4, 7, 
      3, 1, 2, 2, 6, 2, 3 },
    { 2,
      3, 0, 4, 4, 5, 4, 7, 
      3, 1, 2, 2, 6, 2, 3 },
    { 3,
      3, 0, 3, 4, 5, 1, 2, 
      3, 4, 5, 1, 7, 1, 2, 
      3, 1, 7, 4, 5, 4, 7 },
    { 2,
      3, 0, 4, 4, 5, 4, 7, 
      3, 0, 1, 1, 7, 1, 2 },
    
    { 2,
      3, 0, 3, 4, 7, 0, 1,
      3, 0, 3, 4, 5, 4, 7 },
    { 1, 3, 0, 4, 4, 5, 4, 7 },
    { 2,
      3, 0, 4, 2, 6, 3, 5,
      3, 0, 4, 1, 7, 2, 6 },
    { 3,
      3, 1, 7, 2, 6, 3, 5, 
      3, 1, 7, 3, 5, 0, 1, 
      3, 0, 1, 3, 5, 0, 3 },
    { 3,
      3, 0, 4, 2, 6, 3, 5, 
      3, 1, 2, 0, 4, 0, 1,  
      3, 0, 4, 1, 2, 2, 6 },
    { 2,
      3, 0, 3, 1, 2, 3, 5, 
      3, 1, 2, 2, 6, 3, 5 },
    { 3, 
      3, 1, 7, 3, 5, 0, 4, 
      3, 1, 2, 2, 3, 1, 7, 
      3, 2, 3, 3, 5, 1, 7 },
    { 2, 
      3, 0, 1, 1, 7, 1, 2, 
      3, 0, 3, 2, 3, 3, 5 },
    { 2,
      3, 0, 1, 2, 3, 0, 4, 
      3, 0, 4, 2, 3, 3, 5 }, 
    { 1, 3, 0, 3, 3, 5, 2, 3 },
    { 3,
      3, 0, 3, 0, 4, 2, 3, 
      3, 0, 4, 2, 6, 2, 3, 
      3, 1, 7, 2, 6, 0, 4 },
    { 2,
      3, 0, 1, 2, 6, 2, 3,
      3, 0, 1, 1, 7, 2, 6 },
    { 2,
      3, 1, 2, 2, 6, 2, 3,
      3, 0, 3, 0, 4, 0, 1 },    
    { 1, 3, 1, 2, 2, 6, 2, 3 },
    { 2, 
      3, 0, 3, 0, 4, 1, 2,  
      3, 1, 2, 0, 4, 1, 7 }, 
    { 1, 3, 0, 1, 1, 7, 1, 2 },
    { 1, 3, 0, 3, 0, 4, 0, 1 },
    { 0 }
};
const int hex_num_surf = 6;                   //!< \#surfaces defining hex
const int hex_surface_table[][4] = {          //!< local nodes defining surfaces
   {0,1,2,3},{5,6,7,4},{3,2,6,5},{0,4,7,1},{3,5,4,0},{1,7,6,2}
};


/** read in the point file */
bool Hexahedron :: read( const char *fname )
{
  gzFile in;

  try {
    in = openFile( fname, "hex" );
  } catch (...) {return false;}

  const int bufsize=1024;
  char buff[bufsize];
  if ( gzgets(in, buff, bufsize) == Z_NULL ) return false;
  sscanf( buff, "%d", &_n );
  _node    = new int[8*_n];
  _region = new int[_n];

  for ( int i=0; i<_n; i++ ) {
    gzgets(in, buff, bufsize);
    if ( sscanf( buff, "%d %d %d %d %d %d %d %d %d", _node+8*i, _node+8*i+1,
                 _node+8*i+2, _node+8*i+3, _node+8*i+4, _node+8*i+5,
                 _node+8*i+6, _node+8*i+7, _region+i  ) < 9 ) {
      // if region not specified, assign a default of -1
      _region[i] = -1;
    }
  }
  gzclose(in);
  return true;
}


/** draw the faces of an element not contaiining a node
 *
 * \param cn do not draw faces associated with this node
 */
void Hexahedron::draw_out_face( int cn )
{
#if 0
  for ( int i=0; i<_n*_ptsPerObj; i++ )
    if ( _node[i] == cn ) {
      int nn      = i%_ptsPerObj;
      int elenode = i - nn;

      glBegin(GL_QUADS);
      if ( nn<4 ) {
        glVertex3fv( _pt->pt(_node[elenode+4]) );
        glVertex3fv( _pt->pt(_node[elenode+5]) );
        glVertex3fv( _pt->pt(_node[elenode+6]) );
        glVertex3fv( _pt->pt(_node[elenode+7]) );
      } else {
        glVertex3fv( _pt->pt(_node[elenode+0]) );
        glVertex3fv( _pt->pt(_node[elenode+1]) );
        glVertex3fv( _pt->pt(_node[elenode+2]) );
        glVertex3fv( _pt->pt(_node[elenode+3]) );
      }
      if ( nn==0 || nn==3 || nn==4 || nn==5 ) {
        glVertex3fv( _pt->pt(_node[elenode+1]) );
        glVertex3fv( _pt->pt(_node[elenode+7]) );
        glVertex3fv( _pt->pt(_node[elenode+6]) );
        glVertex3fv( _pt->pt(_node[elenode+2]) );
      } else {
        glVertex3fv( _pt->pt(_node[elenode+0]) );
        glVertex3fv( _pt->pt(_node[elenode+3]) );
        glVertex3fv( _pt->pt(_node[elenode+5]) );
        glVertex3fv( _pt->pt(_node[elenode+4]) );
      }
      if ( nn==0 || nn==1 || nn==7 || nn==4 ) {
        glVertex3fv( _pt->pt(_node[elenode+3]) );
        glVertex3fv( _pt->pt(_node[elenode+2]) );
        glVertex3fv( _pt->pt(_node[elenode+6]) );
        glVertex3fv( _pt->pt(_node[elenode+5]) );
      } else {
        glVertex3fv( _pt->pt(_node[elenode+0]) );
        glVertex3fv( _pt->pt(_node[elenode+4]) );
        glVertex3fv( _pt->pt(_node[elenode+7]) );
        glVertex3fv( _pt->pt(_node[elenode+1]) );
      }
      glEnd();
    }
#endif
}


/** determine if a clipping plane intersects an element.
 *
 *  \param pd     visible points
 *  \param cp     clipping plane, cp[0]x + cp[1]y +cp[2]z + cp[3] = 0
 *  \param e      the element in the list
 *  \param interp construct to interpolate data
 *
 *  \return a surface element if intersection, NULL otherwise
 *
 *  \post interp may be allocated
 */
SurfaceElement*
Hexahedron::cut( char*pd, GLfloat* cp,
                 Interpolator<DATA_TYPE>* &interp, int e )
{
  return planecut( pd, cp, interp, hex_num_edge, hex_edges, e );
}


/* return the list of intersection polygons for isosurfaces
 *
 *  \param index for each node, the bit is true if the isoval is exceeded
 *  
 * \return the row in the table
 */
const int* Hexahedron::iso_polys(unsigned int index)
{
  return hex_iso_table[index];
}


/* 
 * return list of lists of nodes defining the bounding surfaces
 *
 * \param ft   face table to be filled in
 * \param v    element number
 * \param tris surfaces as tris 
 *
 * \param pointer to a vector of vectors
 */
int
Hexahedron::surfaces( int ft[][MAX_NUM_SURF_NODES+1], bool tris, int v )
{
  return make_surf_nodelist( v, ft, hex_num_surf, 
          int(hex_surface_table[1]-hex_surface_table[0]), 
                             (const int**)hex_surface_table, tris );
}


const int*
Hexahedron::edges(int &n)
{
  n = hex_num_edge;
  return (const int*)hex_edges;
}
