// Matrix4x4.C
// (c) Ingmar Bitter '96-'99
// $Id: Matrix4x4.C,v 1.3 2005/09/21 20:08:05 vigmond Exp $

// Matrix stored Type matrix[colums][rows]
// second element is second entry of first row denoted by e[1][0]
// indices are viewed as x/y-coords of the positions in the matrix
// thus the first entry is colum number, second is row number

#include "Matrix4x4.h"

template<>
void Matrix4x4<int>::Demo(int, char **)
{
  Matrix4x4<double> a, b(1,0,0,0, 0,2,0,0, 0,0,3,0, 0,0,0,1);
	double s = 2.5; int i = 2;
	Vector3D<double> v(2.5,2.5,2.5);
	std::cout << std::endl <<"Demo of class Matrix4x4";
	std::cout << std::endl <<"size : " << sizeof(Matrix4x4<int>) << " Bytes";
	std::cout << std::endl <<"public member functions:";
	std::cout << std::endl <<"  Matrix4x4<int> a; == " << a;
	std::cout << std::endl <<"  Matrix4x4<int> b; == "<< b;
	std::cout << std::endl <<"  a==b;\t== " << (a==b) <<"  \ta!=b;\t== " << (a!=b);
	std::cout << std::endl <<"  a=b;\t== " << (a=b);
	std::cout << std::endl <<"  +a;\t== " << (+a) ; // <<"\t a+b;\t== " << (a+b);
	std::cout << std::endl <<"  -a;\t== " << (-a) ; // <<"\t a-b;\t== " << (a-b);
	std::cout << std::endl <<"  a+=b;\t== " << (a+=b);
	std::cout << std::endl <<"  a-=b;\t== " << (a-=b);
	std::cout << std::endl <<"  double s(2.5);\t== "<< s <<"  int i(2);";
  Matrix4x4<double> m(a);
	std::cout << std::endl <<"  Matrix4x4<double> m(a);";
	std::cout << std::endl <<"  m*s;\t== " << (m*s);
	std::cout << std::endl <<"  m*i;\t== " << (m*i);
	std::cout << std::endl <<"  m*=i;\t== "<< (m*=i);
	std::cout << std::endl <<"  m/s;\t== " << (m/s);
	std::cout << std::endl <<"  m/=i;\t== "<< (m/=i);
	std::cout << std::endl <<"  Vector3D<double> v(2.5,2.5,2.5);\t== "<< v ;
	Vector3D<double> vi(2,2,2);
	std::cout << std::endl <<"  Vect or3D<int> vi(2,2,2); == "<<vi;
	std::cout << std::endl <<"  m;\t== " << (m);
	std::cout << std::endl <<"  m*v;\t== " << (m*v);
	std::cout << std::endl <<"  m*vi;\t== " << (m*vi);
	std::cout << std::endl <<"  m.AddTranslateX(3);\t== " << (m.AddTranslateX(3));
	std::cout << std::endl <<"  m.AddTranslateY(4);\t== " << (m.AddTranslateY(4));
	std::cout << std::endl <<"  m.AddTranslateZ(5);\t== " << (m.AddTranslateZ(5));
	std::cout << std::endl <<"  m*v;\t== " << (m*v);	
	std::cout << std::endl <<"  m*b;\t== " << (m*b);
	std::cout << std::endl <<"  m*=m;\t== " << (m*=m);
	std::cout << std::endl <<"  m.Transpose();\t== " << m.Transpose();
	std::cout << std::endl <<"  m.Trans();    \t== " << m.Trans();
	std::cout << std::endl <<"  m.Determinant();\t== " << m.Determinant();
	std::cout << std::endl <<"  m.Det();        \t== " << m.Det();
	std::cout << std::endl <<"  m.Inverse();\t== " << m.Inverse();
	std::cout << std::endl <<"  m.Inv();    \t== " << m.Inv();
  Vector3D<double> u(-1,0,2);
  std::cout<<std::endl<<"  u="<<u<<"  m*u="<<(m*u);
  m.Translate(1,1,1);
  std::cout<<std::endl<<"  u="<<u<<"  m*u="<<(m*u);
  m.Scale(.5,.5,.5);
  std::cout<<std::endl<<"  u="<<u<<"  m*u="<<(m*u);
	std::cout << std::endl <<"End of demo of class Matrix4x4\n\n";
} // Demo

// end of Matrix4x4.C
