// ModInt.C
// (c) Ingmar Bitter '96-'99 / Hanspeter Pfister '97
// $Id: ModInt.C,v 1.1 2004/02/06 21:50:57 vigmond Exp $

#include "ModInt.h"

void ModInt::Demo(int , char **) 
{
  ModInt k(3), l(5,3), m(l), n;

  std::cout << std::endl <<"Demo of class ModInt";
  std::cout << std::endl <<"size : " << sizeof(ModInt) << " Bytes";
  std::cout << std::endl <<"public members: - none";
  std::cout << std::endl <<"public member functions:";

  std::cout << std::endl <<"Constructors";

  std::cout << std::endl <<"  ModInt k(3), l(5,3), m(l), n = "<<k<<", "<<l<<", "<<m<<", "<<n;
  std::cout << std::endl << BoolStr[k==3 && l==2 && m==2 && n==0];

  std::cout << std::endl <<"  k(0,3), k(1,3), k(2,3), k(3,3), k(4,3) = "
       <<k(0,3)<<", "<<k(1,3)<<", "<<k(2,3)<<", "<<k(3,3)<<", "<<k(4,3);
	std::cout << std::endl << BoolStr[k(0,3)==0 && k(1,3)==1 && k(2,3)==2 && k(3,3)==0 && k(4,3)==1];

  std::cout << std::endl <<"  k(0,4), k(1,4), k(2,4), k(3,4), k(4,4) = "
       <<k(0,4)<<", "<<k(1,4)<<", "<<k(2,4)<<", "<<k(3,4)<<", "<<k(4,4);
	std::cout << std::endl << BoolStr[k(0,4)==0 && k(1,4)==1 && k(2,4)==2 && k(3,4)==3 && k(4,4)==0];

  std::cout << std::endl <<"  k(-1,3), k(-2,3), k(-3,3), k(-4,3) = "
       <<k(-1,3)<<", "<<k(-2,3)<<", "<<k(-3,3)<<", "<<k(-4,3);
	std::cout << std::endl << BoolStr[k(-1,3)==2 && k(-2,3)==1 && k(-3,3)==0 && k(-4,3)==2];

	std::cout << std::endl <<"  k.Abs() = "<< k.Abs();
	std::cout << std::endl << BoolStr[k.Abs()==2];

  std::cout << std::endl <<"Comparisons";

  std::cout << std::endl <<"  k==k = "<<(k==k)<<"\tk<=k = "<<(k<=k)<<"\tk<k = "<<(k<k) 
       <<"\tk==9 = "<<(k==9)<<"\t9.<=k = "<<(9.<=k)<<"\tk<n = "<<(k<n);
	std::cout << std::endl << BoolStr[(k==k)==1 && (k<=k)==1 && (k<k)==0 && (k==9)==0 
                                 && (9.<=k)==0 && (k<n)==0];

  std::cout << std::endl <<"  k!=k = "<<(k!=k)<<"\tk>=k = "<<(k>=k)<<"\tk>k = "<<(k>k)
       <<"\tk!=9 = "<<(k!=9)<<"\t9.>=k = "<<(9.>=k)<<"\tk>n = "<<(k>n);
	std::cout << std::endl << BoolStr[(k!=k)==0 && (k>=k)==1 && (k>k)==0 && (k!=9)==1 
                                 && (9.>=k)==1 && (k>n)==1];

  std::cout << std::endl <<"Unary Operators";

  std::cout << std::endl <<"  ++k  = "<<(++k);
	std::cout << std::endl << BoolStr[k==0];
  std::cout << std::endl <<"  k++  = "<<(k++);
	std::cout << std::endl << BoolStr[k==1];
  std::cout << std::endl <<"  --k  = "<<(--k);
	std::cout << std::endl << BoolStr[k==0];
  std::cout << std::endl <<"  k--  = "<<(k--);
	std::cout << std::endl << BoolStr[k==2];
  std::cout << std::endl <<"  k--  = "<<(k--);
	std::cout << std::endl << BoolStr[k==1];
  std::cout << std::endl <<"  k--  = "<<(k--);
	std::cout << std::endl << BoolStr[k==0];
  std::cout << std::endl <<"  k--  = "<<(k--);
	std::cout << std::endl << BoolStr[k==2];
  std::cout << std::endl <<"  k--  = "<<(k--);
	std::cout << std::endl << BoolStr[k==1];

  std::cout << std::endl <<"ModInt op ModInt";
  k(1,5);
  n(2,5);
  std::cout << std::endl <<"  k = " << k << "\tn = " << n;

  std::cout << std::endl <<"  k+=n  = "<<(k+=n);
	std::cout << std::endl << BoolStr[k==3];
  std::cout << std::endl <<"  k*=n  = "<<(k*=n);
	std::cout << std::endl << BoolStr[k==1];
  std::cout << std::endl <<"  k-=n  = "<<(k-=n);
	std::cout << std::endl << BoolStr[k==4];
  std::cout << std::endl <<"  k/=n  = "<<(k/=n);
	std::cout << std::endl << BoolStr[k==2];

  k(4,5);
  n(2,5);
  std::cout << std::endl <<"  k = " << k << "\tn = " << n;

  std::cout << std::endl <<"  k+n  = "<<(k+n) <<"\tk-n  = "<<(k-n);
  std::cout         <<"\tk*n  = "<<(k*n) <<"\tk/n  = "<<(k/n);
	std::cout << std::endl << BoolStr[(k+n)==1 && (k-n)==2 && (k*n)==3 && (k/n)==2]; 
 
  std::cout << std::endl <<"ModInt op double";
  k(4,5);
  double a(2.2);
  std::cout << std::endl <<"  k = " << k << "\ta = " << a;

	std::cout << std::endl <<"  k+=a = "<<(k+=a);
	std::cout << std::endl << BoolStr[k==1];
  std::cout << std::endl <<"  k-=a = "<<(k-=a);
	std::cout << std::endl << BoolStr[k==4];
	std::cout << std::endl <<"  k*=a = "<<(k*=a);
	std::cout << std::endl << BoolStr[k==3];
  std::cout << std::endl <<"  k/=a = "<<(k/=a);
	std::cout << std::endl << BoolStr[k==1];
    
	std::cout << std::endl <<"  k+a = "<<(k+a) << "\tk-a = "<<(k-a);
	std::cout         <<"\tk*a = "<<(k*a) <<"\tk/a = "<<(k/a);
	std::cout << std::endl << BoolStr[(k+a)==3 && (k-a)==4 && 
                                 (k*a)==2 && (k/a)==0]; 

  std::cout << std::endl <<"double op ModInt";
  k(4,5);
  std::cout << std::endl <<"  k = " << k << "\ta = " << a;

	std::cout << std::endl <<"  a+k = "<<(a+k) << "\ta-k = "<<(a-k);
	std::cout         <<"\ta*k = "<<(a*k) <<"\ta/k = "<<(a/k);
	std::cout << std::endl << BoolStr[(a+k)==(2.2+4) && (a-k)==(2.2-4) && 
                                 (a*k)==(2.2*4) && (a/k)==(2.2/4)]; 

	std::cout << std::endl <<"  a+=k = "<<(a+=k);
	std::cout << std::endl << BoolStr[a==6.2];
  std::cout << std::endl <<"  a-=k = "<<(a-=k);
	std::cout << std::endl << BoolStr[a==2.2];
	std::cout << std::endl <<"  a*=k = "<<(a*=k);
	std::cout << std::endl << BoolStr[a==8.8];
  std::cout << std::endl <<"  a/=k = "<<(a/=k);
	std::cout << std::endl << BoolStr[a==2.2];

	ModInt array[6];
  int i = 0;
	for (k(0); i<10; ++k, ++i)
    std::cout << std::endl << " array["<<k<<"] = "<<(array[k] = k);

  std::cout << std::endl <<"End of demo of class ModInt\n\n";
}	//	Demo


// end of ModInt.C

